require "player.lua"
require "background.lua"
require "collisionmanager.lua"
require "enemy.lua"


function love.load()

love.graphics.setMode(640, 480, false, true, 0)

love.graphics.setCaption("Space Game Test")


collisionManager = CollisionManagerBuilder:new()


player = PlayerBuilder:new(

{

image = love.graphics.newImage("player.png"),

x = 292,

y = 466,

z = 10

}

)


enemy = EnemyBuilder:new(

{

image = love.graphics.newImage("enemy.png"),

x = 292,

y = 200,

z = 10

}

)


background = BackgroundBuilder:new(

{

backgrounds =

{

DrawableBuilder:new({image = love.graphics.newImage("background.png"), z=1}),

DrawableBuilder:new({image = love.graphics.newImage("background2.png"), z=1}),

DrawableBuilder:new({image = love.graphics.newImage("background3.png"), z=1})

}

}

)


collisionManager:addCollisionTables({player}, enemyList)


collisionManager:addCollisionTables(playerWeaponsList, enemyList)

end


function love.draw()

for i=1, # drawableList do

drawableList[i]:draw()

end

end


function love.update()

for i=1, # updatableList do

updatableList[i]:update()

end


removeItems(updateListRemove, updatableList)

removeItems(drawableListRemove, drawableList)

removeItems(enemyListRemove, enemyList)

removeItems(playerWeaponsListRemove, playerWeaponsList)

end


function removeItems(itemsToRemove, source)

for i=1, #itemsToRemove do

for j=1, #source do

if source[j] == itemsToRemove[i] then

table.remove(source, j)

break

end

end

itemsToRemove[i] = nil

end

end
